--[[
The Broken Mirror Augment Swapper v1.7 by MrInfernal

ToDo:
Weapon augs

Note: 
Plane of Health merchants:
Weapon Augs: Shirlell Isnamgam
]]

---@type Mq
local mq = require('mq')
---@type ImGui
local imgui = require 'ImGui'

local myLevel = mq.TLO.Me.Level()
local myClass = mq.TLO.Me.Class.ShortName()
RoT = mq.TLO.Me.AltCurrency('Remnants of Tranquility')()
local augPrefixIndex = 1 -- For aug level
local type5Index = 1
local type9Index = 1
local sellOldAugs = false
local priestClass = {'DRU', 'SHM', 'CLR'}
local casterClass = {'ENC', 'MAG', 'NEC', 'WIZ'}
local meleeClass = {'BER', 'MNK', 'ROG'}
local hybridClass = {'BRD', 'RNG', 'BST'}
local tankClass = {'WAR', 'PAL', 'SHD'}
local doVis = true
local doNonVis = false
--local doWep = false
local doDebug = false
local myClassGroup = 'Tank' -- Default value. WAR, PAL, and SHD
local showGearTab = false
local showVisBoxes = false
local showNonVisBoxes = false
MakeGear = 'armor'
MakeType = 5
Suffix = type5Index
AugRun = false
VisGear = {}
NonVisGear = {}
WepGear = {}

local doHead = false
local doArms = false
local doLWrist = false
local doRWrist = false
local doHands = false
local doChest = false
local doLegs = false
local doFeet = false
local doLEar = false
local doREar = false
local doFace = false
local doNeck = false
local doShoulder = false
local doBack = false
local doLFinger = false
local doRFinger = false
local doWaist = false
local doCharm = false
local doRanged = false

local function resetCheckboxes()
    doHead = false
    doArms = false
    doLWrist = false
    doRWrist = false
    doHands = false
    doChest = false
    doLegs = false
    doFeet = false
    doLEar = false
    doREar = false
    doFace = false
    doNeck = false
    doShoulder = false
    doBack = false
    doLFinger = false
    doRFinger = false
    doWaist = false
    doCharm = false
    doRanged = false
end

resetCheckboxes()

local augPrefix = {
    '75: Elegant',
    '80: Stalwart',
    '85: Extravagant',
    '90: Glorious',
    '95: Regal',
    '100: August',
    '105: Resplendent'
}

local type5Suffix = {
    'Stability: All', --1
    'Courage: STR',
    'Resilience: STA',
    'Deftness: DEX', --4
    'Swiftness: AGI',
    'Scholarship: INT',
    'Foresight: WIS',
    'Allure: CHA' --8
}

local type9Suffix = {
    'Fulcrum: All', --1
    'Sturdy: +AC - Less HP/Mana',
    'Valiant: +HP - Less Mana', --3
    'Resourceful: +Mana - Less HP',
    'Beneficent: +Heal',
    'Vengeful: +Spell DMG - +Attack', --6
}

-- To group classes for setting aug defaults
local function setDefaultAugs()
    for _, class in ipairs(priestClass) do
        if class == myClass then
            myClassGroup = 'Priest'
        end
    end

    for _, class in ipairs(casterClass) do
        if class == myClass then
            myClassGroup = 'Caster'
        end
    end

    for _, class in ipairs(meleeClass) do
        if class == myClass then
            myClassGroup = 'Melee'
        end
    end

    for _, class in ipairs(hybridClass) do
        if class == myClass then
            myClassGroup = 'Hybrid'
        end
    end

    -- Set default type 9 according to Almar's Guide
    if myClassGroup == 'Hybrid' or myClassGroup == 'Caster' then
        type9Index = 4
    elseif myClassGroup == 'Melee' then
        type9Index = 6
    elseif myClassGroup == 'Priest' then
        type9Index = 3
    elseif myClassGroup == 'Tank' then
        type9Index = 2
    end

    -- Set default type 5
    if myClassGroup == 'Hybrid' or myClassGroup == 'Tank' or myClassGroup == 'Melee' then
        type5Index = 4
    elseif myClassGroup == 'Priest' then
        type5Index = 7
    elseif myClassGroup == 'Caster' then
        type5Index = 6
    end

    -- Set aug level and change type 9 if needed
    if myLevel >= 105 then
        augPrefixIndex = 7
        if myClassGroup == 'Melee' then
            type9Index = 1
        elseif myClassGroup == 'Caster' then
            type9Index = 6
        elseif myClassGroup == 'Priest' then
            type9Index = 5
        end
    elseif myLevel >= 100 then
        augPrefixIndex = 6
        if myClassGroup == 'Caster' or myClassGroup == 'Hybrid' then
            type9Index = 4
        end
    elseif myLevel >= 95 then
        augPrefixIndex = 5
    elseif myLevel >= 90 then
        augPrefixIndex = 4
    elseif myLevel >= 85 then
        augPrefixIndex = 3
    elseif myLevel >= 80 then
        augPrefixIndex = 2
    elseif myLevel >= 75 then
        augPrefixIndex = 1
    end
end

local function makeGearTables()
    local gearSlotVis = {
        'head', -- 1
        'arms',
        'leftwrist',
        'rightwrist',
        'hands',  -- 5
        'chest',
        'legs',
        'feet',  -- 8
    }

    local gearSlotNonVis = {
        'leftear', -- 1
        'rightear',
        'face',
        'neck',
        'shoulder',  -- 5
        'back',
        'leftfinger',
        'rightfinger',
        'waist',
        'charm',  -- 10
        'ranged' -- 11
    }

    local gearSlotWep = {
        'mainhand',
        'offhand',
        'ranged'
    }

    -- Create tables for different gear types
    for _, slot in ipairs(gearSlotVis) do
        table.insert(VisGear, mq.TLO.Me.Inventory(slot))
    end

    for _, slot in ipairs(gearSlotNonVis) do
        table.insert(NonVisGear, mq.TLO.Me.Inventory(slot))
    end

    for _, slot in ipairs(gearSlotWep) do
        table.insert(WepGear, mq.TLO.Me.Inventory(slot))
    end
end

-- Get combobox values to construct aug name
local function getAugName(type, level, suffix)
    local augName = ''

    local prefix = {
        'Elegant', -- 1
        'Stalwart',
        'Extravagant',
        'Glorious', -- 4
        'Regal',
        'August',
        'Resplendent' -- 7
    }
    
    local suffix5 = {
        'Stability', --1
        'Courage',
        'Resilience',
        'Deftness', --4
        'Swiftness',
        'Scholarship',
        'Foresight',
        'Allure' --8
    }

    local suffix9 = {
        'the Fulcrum', --1
        'the Sturdy',
        'the Valiant', --3
        'the Resourceful',
        'the Beneficent',
        'the Vengeful', --6
    }

    if type == 5 then
        augName = prefix[level] .. ' Sulstone of ' .. suffix5[suffix]
    elseif type == 9 then
        augName = prefix[level] .. ' Sulstone of ' .. suffix9[suffix]
    end

    return augName
end

-- Check gear for available aug slots
-- Will check if proper type and if already slotted
local function countAugs(gearTable, type, level, suffix)
    local count = 0
    local cost = 0
    local solvCount = 0
    local name = getAugName(type, level, suffix)
    local gearForAugs = {}
    local removedAugs = {}
    local solvNames = {}

    --[['weps' 
        1h/shield: aug2: 5, aug4: 9
           2h:     aug3: 5, aug5: 9]]

    for _, gear in ipairs(VisGear) do
        if gearTable == 'armor' and doVis then
            if type == 5 then
                local aug1SolventName = gear.AugSlot(1).Solvent.Name()
                if (gear.AugSlot(1).Empty() or gear.AugSlot(1).Name() ~= name) and gear.AugSlot(1).Type() == 5 then
                    count = count + 1
                    showVisBoxes = true
                    table.insert(gearForAugs, gear)
                    if not gear.AugSlot(1).Empty() then
                        table.insert(removedAugs, gear.AugSlot(1).Name())
                        solvCount = solvCount + 1

                        -- Check if the solvent name is already in solvNames
                        if solvNames[aug1SolventName] then
                            solvNames[aug1SolventName] = solvNames[aug1SolventName] + 1
                        else
                            solvNames[aug1SolventName] = 1
                        end
                    end
                end
            elseif type == 9 then
                local aug3SolventName = gear.AugSlot(3).Solvent.Name()
                if (gear.AugSlot(3).Empty() or gear.AugSlot(3).Name() ~= name) and gear.AugSlot(3).Type() == 9 then
                    count = count + 1
                    showVisBoxes = true
                    table.insert(gearForAugs, gear)
                    if not gear.AugSlot(3).Empty() then
                        table.insert(removedAugs, gear.AugSlot(3).Name())
                        solvCount = solvCount + 1

                        -- Check if the solvent name is already in solvNames
                        if solvNames[aug3SolventName] then
                            solvNames[aug3SolventName] = solvNames[aug3SolventName] + 1
                        else
                            solvNames[aug3SolventName] = 1
                        end
                    end
                end
            end
        end  
    end      

    for _, gear in ipairs(NonVisGear) do
        if gearTable == 'armor' and doNonVis then
            if type == 5 and (gear.Type() == 'Armor' or gear.Type() == 'Charm' or gear.Type() == 'Jewelry') then
                local aug2SolventName = gear.AugSlot(2).Solvent.Name()
                if (gear.AugSlot(2).Empty() or gear.AugSlot(2).Name() ~= name) and gear.AugSlot(2).Type() == 5 then
                    count = count + 1
                    showNonVisBoxes = true
                    table.insert(gearForAugs, gear)
                    if not gear.AugSlot(2).Empty() then
                        table.insert(removedAugs, gear.AugSlot(2).Name())
                        solvCount = solvCount + 1
                        
                        -- Check if the solvent name is already in solvNames
                        if solvNames[aug2SolventName] then
                            solvNames[aug2SolventName] = solvNames[aug2SolventName] + 1
                        else
                            solvNames[aug2SolventName] = 1
                        end
                    end
                end
            elseif type == 9 and (gear.Type() == 'Armor' or gear.Type() == 'Charm' or gear.Type() == 'Jewelry') then
                local aug4SolventName = gear.AugSlot(2).Solvent.Name()
                if (gear.AugSlot(4).Empty() or gear.AugSlot(4).Name() ~= name) and gear.AugSlot(4).Type() == 9 then
                    count = count + 1
                    showNonVisBoxes = true
                    table.insert(gearForAugs, gear)
                    if not gear.AugSlot(4).Empty() then
                        table.insert(removedAugs, gear.AugSlot(4).Name())
                        solvCount = solvCount + 1
                        
                        -- Check if the solvent name is already in solvNames
                        if solvNames[aug4SolventName] then
                            solvNames[aug4SolventName] = solvNames[aug4SolventName] + 1
                        else
                            solvNames[aug4SolventName] = 1
                        end
                    end
                end
            end
        end
    end

    for _, solv in ipairs(solvNames) do
        if solvNames[solv] then
            solvNames[solv] = solvNames[solv] + 1
        else
            solvNames[solv] = 1
        end
    end

    if level == 1 then
        cost = count * 50
    elseif level == 2 then
        cost = count * 90
    elseif level == 3 then
        cost = count * 190
    elseif level == 4 then
        cost = count * 380
    elseif level == 5 then
        cost = count * 630
    elseif level == 6 then
        cost = count * 940
    elseif level == 7 then
        cost = count * 1250
    end

    -- Iterate through gearForAugs to turn on checkboxes
    for _, gear in ipairs(gearForAugs) do
        if gear.ItemSlot() == 0 then
            doCharm = true
        elseif gear.ItemSlot() == 1 then
            doLEar = true
        elseif gear.ItemSlot() == 2 then
            doHead = true
        elseif gear.ItemSlot() == 3 then
            doFace = true
        elseif gear.ItemSlot() == 4 then
            doREar = true
        elseif gear.ItemSlot() == 5 then
            doNeck = true
        elseif gear.ItemSlot() == 6 then
            doShoulder = true
        elseif gear.ItemSlot() == 7 then
            doArms = true
        elseif gear.ItemSlot() == 8 then
            doBack = true
        elseif gear.ItemSlot() == 9 then
            doLWrist = true
        elseif gear.ItemSlot() == 10 then
            doRWrist = true
        elseif gear.ItemSlot() == 11 then
            doRanged = true
        elseif gear.ItemSlot() == 12 then
            doHands = true
        --elseif gear.ItemSlot() == 13 then
            --doMainHand = true
        --elseif gear.ItemSlot() == 14 then
            --doOffHand = true
        elseif gear.ItemSlot() == 15 then
            doLFinger = true
        elseif gear.ItemSlot() == 16 then
            doRFinger = true
        elseif gear.ItemSlot() == 17 then
            doChest = true
        elseif gear.ItemSlot() == 18 then
            doLegs = true
        elseif gear.ItemSlot() == 19 then
            doFeet = true
        elseif gear.ItemSlot() == 20 then
            doWaist = true
        end
    end

    if count > 0 then
        showGearTab = true
    else
        showGearTab = false
    end

    return count, name, cost, solvCount, gearForAugs, removedAugs, solvNames
end

local function countForBuy(gearTable, type, level, suffix)
    local count = 0
    local cost = 0
    local solvCount = 0
    local name = getAugName(type, level, suffix)
    local gearForAugs = {}
    local removedAugs = {}
    local solvNames = {}

    print(name)

    local itemSlots = {
        {slot = 0, var = doCharm},
        {slot = 1, var = doLEar},
        {slot = 2, var = doHead},
        {slot = 3, var = doFace},
        {slot = 4, var = doREar},
        {slot = 5, var = doNeck},
        {slot = 6, var = doShoulder},
        {slot = 7, var = doArms},
        {slot = 8, var = doBack},
        {slot = 9, var = doLWrist},
        {slot = 10, var = doRWrist},
        {slot = 11, var = doRanged},
        {slot = 12, var = doHands},
        -- {slot = 13, var = doMainHand},
        -- {slot = 14, var = doOffHand},
        {slot = 15, var = doLFinger},
        {slot = 16, var = doRFinger},
        {slot = 17, var = doChest},
        {slot = 18, var = doLegs},
        {slot = 19, var = doFeet},
        {slot = 20, var = doWaist}}

    --[['weps' 
        1h/shield: aug2: 5, aug4: 9
           2h:     aug3: 5, aug5: 9]]

    for _, gear in ipairs(VisGear) do
        if gearTable == 'armor' and doVis then
            if type == 5 then
                if (gear.AugSlot(1).Empty() or gear.AugSlot(1).Name() ~= name) and gear.AugSlot(1).Type() == 5 then
                    for _, item in ipairs(itemSlots) do
                        if gear.ItemSlot() == item.slot  and item.var then
                            local aug1SolventName = gear.AugSlot(1).Solvent.Name()
                            count = count + 1
                            showVisBoxes = true
                            table.insert(gearForAugs, gear)
                            if not gear.AugSlot(1).Empty() then
                                table.insert(removedAugs, gear.AugSlot(1).Name())
                                solvCount = solvCount + 1
                                
                                -- Check if the solvent name is already in solvNames
                                if solvNames[aug1SolventName] then
                                    solvNames[aug1SolventName] = solvNames[aug1SolventName] + 1
                                else
                                    solvNames[aug1SolventName] = 1
                                end
                            end
                        end
                    end
                end
            elseif type == 9 then
                if (gear.AugSlot(3).Empty() or gear.AugSlot(3).Name() ~= name) and gear.AugSlot(3).Type() == 9 then
                    for _, item in ipairs(itemSlots) do
                        if gear.ItemSlot() == item.slot  and item.var then
                            local aug3SolventName = gear.AugSlot(3).Solvent.Name()
                            count = count + 1
                            showVisBoxes = true
                            table.insert(gearForAugs, gear)
                            if not gear.AugSlot(3).Empty() then
                                table.insert(removedAugs, gear.AugSlot(3).Name())
                                solvCount = solvCount + 1
                                
                                -- Check if the solvent name is already in solvNames
                                if solvNames[aug3SolventName] then
                                    solvNames[aug3SolventName] = solvNames[aug3SolventName] + 1
                                else
                                    solvNames[aug3SolventName] = 1
                                end
                            end
                        end
                    end
                end
            end
        end  
    end      

    for _, gear in ipairs(NonVisGear) do
        if gearTable == 'armor' and doNonVis then
            if type == 5 and (gear.Type() == 'Armor' or gear.Type() == 'Charm' or gear.Type() == 'Jewelry') then
                if (gear.AugSlot(2).Empty() or gear.AugSlot(2).Name() ~= name) and gear.AugSlot(2).Type() == 5 then
                    for _, item in ipairs(itemSlots) do
                        if gear.ItemSlot() == item.slot  and item.var then
                            local aug2SolventName = gear.AugSlot(2).Solvent.Name()
                            count = count + 1
                            showNonVisBoxes = true
                            table.insert(gearForAugs, gear)
                            if not gear.AugSlot(2).Empty() then
                                table.insert(removedAugs, gear.AugSlot(2).Name())
                                solvCount = solvCount + 1
                                
                                -- Check if the solvent name is already in solvNames
                                if solvNames[aug2SolventName] then
                                    solvNames[aug2SolventName] = solvNames[aug2SolventName] + 1
                                else
                                    solvNames[aug2SolventName] = 1
                                end
                            end
                        end
                    end
                end
            elseif type == 9 and (gear.Type() == 'Armor' or gear.Type() == 'Charm' or gear.Type() == 'Jewelry') then
                if (gear.AugSlot(4).Empty() or gear.AugSlot(4).Name() ~= name) and gear.AugSlot(4).Type() == 9 then
                    for _, item in ipairs(itemSlots) do
                        if gear.ItemSlot() == item.slot  and item.var then
                            local aug4SolventName = gear.AugSlot(4).Solvent.Name()
                            count = count + 1
                            showNonVisBoxes = true
                            table.insert(gearForAugs, gear)
                            if not gear.AugSlot(4).Empty() then
                                table.insert(removedAugs, gear.AugSlot(4).Name())
                                solvCount = solvCount + 1
                                
                                -- Check if the solvent name is already in solvNames
                                if solvNames[aug4SolventName] then
                                    solvNames[aug4SolventName] = solvNames[aug4SolventName] + 1
                                else
                                    solvNames[aug4SolventName] = 1
                                end
                            end
                        end
                    end
                end
            end
        end
    end

    for _, solv in ipairs(solvNames) do
        if solvNames[solv] then
            solvNames[solv] = solvNames[solv] + 1
        else
            solvNames[solv] = 1
        end
    end

    return count, name, cost, solvCount, gearForAugs, removedAugs, solvNames
end

local function checkAugs(gearTable, type, level, suffix)
    local count, name, cost, gearForAugs, removedAugs, solvNames = countAugs(gearTable, type, level, suffix)
    local origCount = count
    local found = 0

    for i=1, mq.TLO.Me.NumBagSlots() do
        local pack = 'pack' .. i

        for j=1, mq.TLO.Me.Inventory(pack).Container() do
            if mq.TLO.Me.Inventory(pack).Item(j).Name() == name then
                count = count - 1
                found = found + 1
            end
        end
    end

    if found > 0 and found == origCount then
        printf('You have \at%d \axof \at%d \ao%s. \n\agNo need to purchase more.', found, origCount, name)
    elseif found > 0 and found < origCount then
        printf('You have \at%d \axof \at%d \ao%s. \n\ax\axYou need to purchase %d more.', found, origCount, name, count)
    elseif count == 0 then
        printf('You do not need to purchase any \ao%s', name)
    else
        printf('Need to purchase \at%d \ao%s \ax\axfor \at%d \axRemnants.', count, name, cost)
    end
end

-- Update AltCurrency from events
local function updateRemnant()
    RoT = mq.TLO.Me.AltCurrency('Remnants of Tranquility')()
end

-- function to run the window
local function tbmAugs(open)
    -- We specify a default position/size in case there's no data in the .ini file.
    local main_viewport = imgui.GetMainViewport()
    imgui.SetNextWindowPos(main_viewport.WorkPos.x + 650, main_viewport.WorkPos.y + 20, ImGuiCond.FirstUseEver)

    -- change the window size
    imgui.SetNextWindowSize(550, 200, ImGuiCond.FirstUseEver)

    local show = false
    open, show = imgui.Begin("TBM Aug Swapper by MrInfernal", open)

    if not show then
        mq.unevent('remnant')
        ImGui.End()
        return open
    end

    ImGui.PushItemWidth(ImGui.GetFontSize() * -12);

    -- Main window element area --
    imgui.Text(mq.TLO.Me.Name() .. '.  Level: ' .. myLevel .. ' ' .. mq.TLO.Me.Class.Name())
    imgui.SameLine(350)
    if imgui.Button('Go to Vendors') then
        if mq.TLO.Zone.ShortName() == 'pohealth' then
            mq.cmd('/easyfind nav locyxz 1331.81, 135.05, 63.49')
        else
            mq.cmd('/travelto "pohealth" @ nav locyxz 1331.81, 135.05, 63.49')
        end
    end
    imgui.SameLine()
    if imgui.Button('Stop Nav') then
        mq.cmd('/nav stop')
    end
    imgui.Text('Remants of Tranquility: %d', RoT)
    imgui.SameLine(455)
    doDebug = imgui.Checkbox('Debug', doDebug)
    imgui.Text('\n')

    imgui.Text('Armor: ')
    imgui.SameLine()
    doVis = imgui.Checkbox('Visible', doVis)
    imgui.SameLine()
    doNonVis = imgui.Checkbox('Nonvisible', doNonVis)

    imgui.Text('Level     ')
    imgui.SameLine()
    augPrefixIndex = imgui.Combo(' ', augPrefixIndex, augPrefix, #augPrefix)
    imgui.SameLine()
    sellOldAugs = imgui.Checkbox(' Sell Augs', sellOldAugs)

    imgui.Text('Type 5: ')
    imgui.SameLine()
    type5Index = imgui.Combo('  ', type5Index, type5Suffix, #type5Suffix)
    imgui.SameLine()
    if imgui.Button(' Check') then
        resetCheckboxes()
        checkAugs('armor', 5, augPrefixIndex, type5Index)
    end
    imgui.SameLine()
    if imgui.Button(' Buy') then
        MakeType = 5
        Suffix = type5Index
        AugRun = true
    end

    imgui.Text('Type 9: ')
    imgui.SameLine()
    type9Index = imgui.Combo('   ', type9Index, type9Suffix, #type9Suffix)
    imgui.SameLine()
    if ImGui.Button("Check") then
        resetCheckboxes()
        checkAugs('armor', 9, augPrefixIndex, type9Index)
    end
    imgui.SameLine()
    if ImGui.Button("Buy") then
        MakeType = 9
        Suffix = type9Index
        AugRun = true
    end
    imgui.Text('')

    if showGearTab then
        if imgui.CollapsingHeader('Gear', ImGuiTreeNodeFlags.DefaultOpen) then
            imgui.Columns(2)
        if showVisBoxes then
            imgui.Text('Visible')

            doHead= imgui.Checkbox('Head', doHead)
            imgui.SameLine(100)
            doChest = imgui.Checkbox('Chest', doChest)

            doArms = imgui.Checkbox('Arms', doArms)
            imgui.SameLine(100)
            doHands = imgui.Checkbox('Hands', doHands)

            doLWrist = imgui.Checkbox('Left Wrist', doLWrist)
            imgui.SameLine(100)
            doRWrist = imgui.Checkbox('Right Wrist', doRWrist)

            doLegs = imgui.Checkbox('Legs', doLegs)
            imgui.SameLine(100)
            doFeet = imgui.Checkbox('Feet', doFeet)
        end
            imgui.NextColumn()
        if showNonVisBoxes then
            imgui.Text('Nonvisible')

            doLEar = imgui.Checkbox('Left Ear', doLEar)
            imgui.SameLine(110)
            doREar = imgui.Checkbox('Right Ear', doREar)

            doFace = imgui.Checkbox('Face', doFace)
            imgui.SameLine(110)
            doNeck = imgui.Checkbox('Neck', doNeck)

            doBack = imgui.Checkbox('Back', doBack)
            imgui.SameLine(110)
            doShoulder = imgui.Checkbox('Shoulders', doShoulder)

            doLFinger = imgui.Checkbox('Left Finger', doLFinger)
            imgui.SameLine(110)
            doRFinger = imgui.Checkbox('Right Finger', doRFinger)

            doWaist = imgui.Checkbox('Waist', doWaist)
            imgui.SameLine(110)
            doCharm = imgui.Checkbox('Charm', doCharm)

            doRanged = imgui.Checkbox('Ranged', doRanged)
        end

            imgui.Columns(1)
        end
    end
    
    -- End of main window element area --
    -- Required for window elements
    imgui.Spacing()
    imgui.PopItemWidth()
    imgui.End()
    return open
end

-- Start events and main functions
mq.event('remnant', '#*#for #1# Remnants of Tranquility#*#', updateRemnant)
setDefaultAugs()
makeGearTables()

local openGUI = true

ImGui.Register('TBM Aug Swapper', function()
    openGUI = tbmAugs(openGUI)
end)

while openGUI do
    mq.doevents()
    mq.delay(1000) -- equivalent to '1s'

    while AugRun do
        local function doAugs(augPrefixIndex)
            local myLevel = mq.TLO.Me.Level()
            local levelCheck = true
            local gearTable = MakeGear
            local type = MakeType
            local level = augPrefixIndex
            local suffix = Suffix
            local stop = false

            --Get a count and cost of the augs
            local count, name, cost, solvCount, gearForAugs, removedAugs, solvNames = countForBuy(gearTable, type, level, suffix)
        
            -- Check if high enough level for selected augs
            if level == 1 and myLevel < 75 then
                levelCheck = false
            elseif level == 2 and myLevel < 80 then
                levelCheck = false
            elseif level == 3 and myLevel < 85 then
                levelCheck = false
            elseif level == 4 and myLevel < 90 then
                levelCheck = false
            elseif level == 5 and myLevel < 95 then
                levelCheck = false
            elseif level == 6 and myLevel < 100 then
                levelCheck = false
            elseif level == 7 and myLevel < 105 then
                levelCheck = false
            end
        
            if not levelCheck then
                printf('Level too low for %s!', name)
                stop = true
                AugRun = false
            end
        
            -- Ensure at least one box is checked
            if not doVis and not doNonVis then
                print('No Armor boxes checked! Choose Visible, Nonvisible, or both.')
                stop = true
                AugRun = false
            end
        
            -- Check for proper zone
            if mq.TLO.Zone.ShortName() ~= 'pohealth' and not doDebug then
                print('\arNot in Plane of Health! Use \agDebug \axto test')
                stop = true
                AugRun = false
            end
        
            -- Pause plugins
            if mq.TLO.Plugin('mq2autoforage').IsLoaded() then
                mq.cmd('/squelch /stopforage')
            end
        
            if mq.TLO.CWTN() then
                mq.cmd('/squelch /${Me.Class.ShortName} pause on')
            end
        
            if not stop then
                if not doDebug then
                    if mq.TLO.Spawn('Montelio').Distance() > 20 or mq.TLO.Spawn('Dabowe').Distance() > 20 then
                        mq.cmd('/easyfind nav locyxz 1331.81, 135.05, 63.49')
                    end
                end
        
                -- Buy distillers if needed
                if doDebug then
                    for solv, scount in pairs(solvNames) do
                        local invSolv = mq.TLO.FindItemCount(solv)()
                        if invSolv > 0 then
                            scount = tonumber(scount) - invSolv
                        end
                    end
                    if not mq.TLO.Merchant.Open() and solvCount > 0 then
                        mq.cmdf('/echo \agDebug: \axNeed to purchase solvents!')
                        mq.delay(1500)
                    end
                    if solvCount > 0 then
                        mq.cmdf('/echo \agDebug: \axOpen Dabowe\'s merchant window')
                        mq.delay(300)
        
                        for solv, scount in pairs(solvNames) do
                            mq.cmdf('/echo \agDebug: \axPurchase \at%s \ao%s', scount, solv)
                            mq.delay(1000)
                        end  
                        mq.cmdf('/echo \agDebug: \ax Closing Dabowe\'s merchant window\n') 
                        mq.delay(1000)
                    end
                else
                    if solvCount > 0 then
                        mq.cmdf('/if (!${Window[Merchant].Open}) /tar Dabowe')
                        mq.delay(200)
                        mq.cmdf('/if (!${Window[Merchant].Open}) /usetarget')
                        mq.delay(300)
        
                        mq.cmdf('/echo Need to purchase solvents!')
                        mq.delay(2500)
        
                        for solv, scount in pairs(solvNames) do
                            mq.cmdf('/invoke ${Merchant.SelectItem[=%s]}', solv)
                            mq.delay(1500)
                            mq.cmdf('/invoke ${Merchant.Buy[%s]}', scount)
                            mq.delay(1000)
                        end
                        mq.cmdf('/notify MerchantWnd MW_Done_Button leftmouseup')
                        mq.delay(1500)
                    end
                end
        
                -- Remove augs from gear
                if doDebug then
                    if #removedAugs > 0 then
                        mq.cmdf('/echo Removing old augs from gear!')
                        mq.delay(500)
                    end
                    for _, gear in ipairs(gearForAugs) do
                        if not gear.AugSlot(1).Empty() then
                            if gear.AugSlot(1).Type() == 5 and gear.AugSlot(1).Name() ~= name and type == 5 then
                                mq.cmdf('/echo \agDebug: \axRemove \ao"%s" \axfrom \ao"%s"', gear.AugSlot(1).Name(), gear)
                                mq.delay(500)
                            end
                        elseif not gear.AugSlot(3).Empty() and gear.AugSlot(3).Name() ~= name and type == 5 then
                            if gear.AugSlot(3).Type() == 5 then
                                mq.cmdf('/echo \agDebug: \axRemove \ao"%s" \axfrom \ao"%s"', gear.AugSlot(3).Name(), gear)
                                mq.delay(500)
                            end
                        elseif not gear.AugSlot(2).Empty() and gear.AugSlot(2).Name() ~= name and type == 9 then
                            if gear.AugSlot(2).Type() == 9 then
                                mq.cmdf('/echo \agDebug: \axRemove \ao"%s" \axfrom \ao"%s"', gear.AugSlot(2).Name(), gear)
                                mq.delay(500)
                            end
                        elseif not gear.AugSlot(4).Empty() and gear.AugSlot(4).Name() ~= name and type == 9 then
                            if gear.AugSlot(4).Type() == 9 then
                                mq.cmdf('/echo \agDebug: \axRemove \ao"%s" \axfrom \ao"%s"', gear.AugSlot(4).Name(), gear)
                                mq.delay(500)
                            end
                        end
                    end
                    mq.cmdf('/echo \agDebug: \ax Removed \at%d \ao%s\n', #removedAugs, name)
                    mq.delay(1000)
                else
                    if #removedAugs > 0 then
                        mq.cmdf('/echo Removing old augs from gear!\n')
                        mq.delay(500)
                    end
                    for _, gear in ipairs(gearForAugs) do
                        if type == 5 and gear.AugSlot(1).Type() == 5 and gear.AugSlot(1).Name() ~= name then
                            if not gear.AugSlot(1).Empty() then
                                mq.cmdf('/removeaug "%s" "%s"', gear.AugSlot(1).Name(), gear)
                                mq.delay(1000)
                                mq.cmdf('/if (${Window[ConfirmationDialogBox].Open}) /notify ConfirmationDialogBox Yes_Button leftmouseup')
                                mq.delay(1000)
                                mq.cmdf('/autoinventory')
                                mq.delay(1000)
                            end
                        elseif type == 9 and gear.AugSlot(3).Type() == 9 and gear.AugSlot(3).Name() ~= name then
                            if not gear.AugSlot(3).Empty() then
                                mq.cmdf('/removeaug "%s" "%s"', gear.AugSlot(2).Name(), gear)
                                mq.delay(1000)
                                mq.cmdf('/if (${Window[ConfirmationDialogBox].Open}) /notify ConfirmationDialogBox Yes_Button leftmouseup')
                                mq.delay(1000)
                                mq.cmdf('/autoinventory')
                                mq.delay(1000)
                            end
                        elseif type == 5 and gear.AugSlot(2).Type() == 5 and gear.AugSlot(2).Name() ~= name then
                            if not gear.AugSlot(2).Empty() then
                                mq.cmdf('/removeaug "%s" "%s"', gear.AugSlot(3).Name(), gear)
                                mq.delay(1000)
                                mq.cmdf('/if (${Window[ConfirmationDialogBox].Open}) /notify ConfirmationDialogBox Yes_Button leftmouseup')
                                mq.delay(1000)
                                mq.cmdf('/autoinventory')
                                mq.delay(1000)
                            end
                        elseif type == 9 and gear.AugSlot(4).Type() == 9 and gear.AugSlot(4).Name() ~= name then
                            if not gear.AugSlot(4).Empty() then
                                mq.cmdf('/removeaug "%s" "%s"', gear.AugSlot(4).Name(), gear)
                                mq.delay(1000)
                                mq.cmdf('/if (${Window[ConfirmationDialogBox].Open}) /notify ConfirmationDialogBox Yes_Button leftmouseup')
                                mq.delay(1000)
                                mq.cmdf('/autoinventory')
                                mq.delay(1000)
                            end
                        end
                    end
                end
        
                -- Sell the old augs
                if sellOldAugs then
                    if #removedAugs > 0 then
                        if doDebug then
                            if not mq.TLO.Merchant.Open() then
                                mq.cmdf('/echo \agDebug: \axOpening Montelio\'s merchant window')
                                mq.delay(300)
                            end
                
                            mq.cmdf('/echo Selling %d old augs!\n', #removedAugs)
                            mq.delay(1500)
                
                            for _, aug in ipairs(removedAugs) do
                                mq.cmdf('/echo \agDebug: \axSelling \ao"%s"', aug)
                                mq.delay(1000)
                            end
                            mq.cmdf('/echo Selling complete\n')
                        else
                            mq.cmdf('/if (!${Window[Merchant].Open}) /tar Montelio')
                            mq.delay(500)
                            mq.cmdf('/if (!${Window[Merchant].Open}) /usetarget')
                            mq.delay(500)
        
                            mq.cmdf('/echo Selling \at%d \axold augs!', #removedAugs)
                            Delay = Delay + 40
        
                            for _, aug in ipairs(removedAugs) do
                                mq.cmdf('/selectitem "%s"', aug)
                                mq.delay(300)
                                mq.cmdf('/invoke ${Merchant.Sell[1]}')
                                mq.delay(1500)
                            end
                        end
                    end
                end
        
                -- Check for augs in inventory before buying
                for i=1, mq.TLO.Me.NumBagSlots() do
                    local pack = 'pack' .. i
            
                    for j=1, mq.TLO.Me.Inventory(pack).Container() do
                        if mq.TLO.Me.Inventory(pack).Item(j).Name() == name then
                            count = count - 1
                        end
                    end
                end
        
                if count > 0 then
                    if doDebug then
                        if cost < RoT then -- If you have enough remnants
                            -- Buy augs
                            if not mq.TLO.Merchant.Open() then
                                mq.cmdf('/echo \agDebug: \axOpen Montelio\'s merchant window')
                                mq.delay(500)
                                mq.cmdf('/echo \agDebug: \axPurchase \at%d \ao%s \ax\axfor \at%d \ax remnants', count, name, cost)
                            end
                            
                            -- Need a for loop to buy all of the augs
                            for i=1, count do
                                mq.cmdf('/echo \agDebug: \ax%d: Buy \ao%s', i, name)
                                mq.delay(1000)
                            end
                            mq.cmdf('/echo \agDebug: \axClosing Montelio\'s merchant window\n')
                            mq.delay(1500)
                        else
                            printf('\agDebug: \ao%s \axcosts \at%d \axand you have \at%d\ax! You need \ar%d \axmore!', name, cost, RoT, cost - RoT)
                            stop = true
                        end
                    else
                        if cost < RoT then -- If you have enough remnants
                            -- Buy augs
                            mq.cmdf('/if (!${Window[Merchant].Open}) /tar Montelio')
                            mq.delay(500)
                            mq.cmdf('/if (!${Window[Merchant].Open}) /usetarget')
                            mq.delay(500)
                            mq.cmdf('/echo Purchasing \at%d \ao%s \ax\axfor \at%d \axRemnants', count, name, cost)
        
                            mq.delay(500)
                            mq.cmdf('/invoke ${Merchant.SelectItem[=%s]}', name)
                            mq.delay(1000)
        
                            -- Loop to buy all of the augs
                            for i=1, count do
                                mq.cmdf('/notify MerchantWnd MW_Buy_Button leftmouseup', count)
                                mq.delay(1000)
        
                                mq.cmdf('/notify ConfirmationDialogBox CD_Yes_Button leftmouseup', count)
                                mq.delay(1500)
        
                            end
                            mq.cmdf('/notify MerchantWnd MW_Done_Button leftmouseup')
                            mq.delay(1500)
                        else
                            printf('%s costs %d and you have %d! You need %d more!', name, cost, RoT, cost - RoT)
                            stop = true
                            AugRun = false
                        end
                    end
                end
        
                -- Insert augs into gear
                if #gearForAugs >0 then
                    mq.cmdf('/echo Inserting \ao%s \axinto \at%d \axpieces of gear!', name, #gearForAugs)
                    mq.delay(1500)
            
                    if doDebug then
                        for _, gear in ipairs(gearForAugs) do
                            mq.cmdf('/echo \agDebug: \axInsert aug into \ao%s', gear) -- Insert aug from cursor into gear
                            mq.delay(1000)
                        end
                    else
                        for _, gear in ipairs(gearForAugs) do                
                            for i=1, mq.TLO.Me.NumBagSlots() do
                                local pack = 'pack' .. i
                                local found = false
                                
                                if not found then
                                    for j=1, mq.TLO.Me.Inventory(pack).Container() do
                                        if mq.TLO.Me.Inventory(pack).Item(j).Name() == name then
                                            mq.cmdf('/itemnotify in %s %d leftmouseup', pack, j)
                                            mq.delay(500)
                                            found = true
                                        end
                                    end
                                end
                            end
        
                            -- Insert aug from cursor into gear
                            mq.cmdf('/echo Inserting aug into %s', gear.Name())
                            mq.cmdf('/insertaug "%s"', gear.Name())
                            mq.delay(2000)
                        end
                    end
                end
                mq.cmdf('/echo  ')
                mq.delay(500)
                mq.cmdf('/echo \agComplete! \axInserted \at%d \ao%s \ax\axinto \at%d \axpieces of gear.', count, name, #gearForAugs)
        
                if mq.TLO.Plugin('mq2autoforage').IsLoaded() then
                    mq.cmd('/squelch /startforage')
                end
        
                mq.cmd('/squelch /${Me.Class.ShortName} pause off')
            end
            AugRun = false
        end
        doAugs(augPrefixIndex)
    end
end